import java.io.*;

public class mg{

   public int power(int number,int pow){
      int sum = 1;
      for (int i=0;i<pow;i++) {
         sum = sum * number;
      }
      return sum;
   }

   static void print_uij(int nx,int ny, double x[], double y[],
               double val[][],String name) throws java.io.IOException{
		PrintStream out;
		out = new PrintStream( new FileOutputStream(name));
//      for (int j=0;j<ny;j++) {
			int j = (ny-1)/2;
         for (int i=0;i<nx;i++) {
            out.println(x[i]+" "+val[j][i]);
         }
//      }
   }

   static void set_up_u(int nx, int ny, double x[], double y[],
                     double u[][], double uxct[][], double h){
      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            uxct[j][i] = 1.0/Math.sqrt(x[i]*x[i]+y[j]*y[j]+0.5);
            u[j][i] = 0.0;
         }
      }
      for (int j=0;j<ny;j++) {
         u[j][0] = uxct[j][0];
         u[j][nx-1] = uxct[j][nx-1];
      }
      for (int i=0;i<nx;i++) {
         u[0][i] = uxct[0][i];
         u[ny-1][i] = uxct[ny-1][i];
      }

   }


   static void set_up_rhs(int nx,int ny,double x[],double y[],double rhs[][]){
      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            rhs[j][i] = 32.0*(x[i]*x[i]+y[j]*y[j]-1.0)/Math.sqrt(
                        (4*x[i]*x[i]+4*y[j]*y[j]+2.0)*
                        (4*x[i]*x[i]+4*y[j]*y[j]+2.0)*
                        (4*x[i]*x[i]+4*y[j]*y[j]+2.0)*
                        (4*x[i]*x[i]+4*y[j]*y[j]+2.0)*
                        (4*x[i]*x[i]+4*y[j]*y[j]+2.0));
         }
      }
   }

   static void restrict(int nxf, int nyf, double uf[][], double uc[][] ){
   double HALF = 0.5;
   double EIGHT = 1.0/8.0;
   int nxc = (nxf+1)/2;
   int nyc = (nyf+1)/2;


      for (int jc=1; jc<nyc-1; jc ++) {
         int jff = 2 * jc;
         for (int ic=1; ic<nxc-1; ic ++) {
            int iff = 2 * ic;
            uc[jc][ic] = HALF*uf[jff][iff] + EIGHT*(
                        uf[jff+1][iff] + uf[jff-1][iff] +
                        uf[jff][iff+1] + uf[jff][iff-1] );
         }
      }
// inject the boundaries....
      for (int jc=0;jc<nyc;jc++) {
         uc[jc][0] = uf[2*jc][0];
         uc[jc][nxc-1] = uf[2*jc][nxf-1];
      }
      for (int ic=0;ic<nxc;ic++) {
         uc[0][ic] = uf[0][2*ic];
         uc[nyc-1][ic] = uf[nyf-1][2*ic];
      }

   }


   static void prolong(int nxf, int nyf, double uc[][], double uf[][] ){
   int nxc = (nxf+1)/2;
   int nyc = (nyf+1)/2;
   int iff,jff;
   double HALF = 0.5;


      for (int jc=0; jc<nyc; jc ++) {
         jff = 2 * jc;
         for (int ic=0; ic<nxc; ic ++) {
            iff = 2 * ic;
            uf[jff][iff] =uc[jc][ic];   // injection
         }
         for (iff=1;iff<nxf-1;iff+=2) {
            uf[jff][iff] = HALF*( uf[jff][iff-1] + uf[jff][iff+1]);
         }
         if (jc > 0 ) {
            for (iff=0;iff<nxf;iff++) {
               uf[jff-1][iff] = HALF*(uf[jff-2][iff]+uf[jff][iff] );
            }
         }
      }

   }

   static void lu(int nx, int ny, double u[][], double h, double lu[][] ){

      double h2    = 1.0/( h * h);
      double jaceli=  1.0/(4.0 * (h * h));
      double sum = 0.0;

      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
         lu[j][i] = 0.0;
         }
      }

      for (int j=1;j<ny-1;j++) {
         for (int i=1;i<nx-1;i++) {

            lu[j][i] = h2 * ( u[j+1][i] + u[j-1][i] +
                               u[j][i+1] + u[j][i-1] -
                               4.0 * u[j][i] );
           }
      }
   }


   static void suba(int nx, int ny, double u1[][],double u2[][],double u3[][]){
      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            u3[j][i] = u1[j][i] - u2[j][i];
         }
      }
   }

   static void adda(int nx, int ny, double u1[][], double u2[][],double u3[][]){
      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            u3[j][i] = u1[j][i] + u2[j][i];
         }
      }
   }


   double erroru(int nx, int ny, double u[][], double ux[][]){
      double error;
      double val;
      error = 0.0;
      for (int j=0;j<ny;j++){
         for (int i=0;i<nx;i++){
            val = u[j][i]-ux[j][i];
            error = error + val * val;
         }
      }
      error = error / nx /ny;
      return error;
   }


   double relaxc(int nx, int ny, double u[][],double rhs[][],
                 double res[][], double h){

      double h2    = 1.0/( h * h);
      double jacel = (h * h)/ 4.0;
      double sum = 0.0;

		int jsw = 0;
		int isw;
		for (int pass=1;pass<3;pass++){
			isw = jsw;
      	for (int j=1;j<ny-1;j++) {
            for (int i=isw+1;i<nx-1;i+=2) {

            	res[j][i] = h2 * ( u[j+1][i] + u[j-1][i] +
                               	u[j][i+1] + u[j][i-1] -
                               	4.0 * u[j][i] )  - rhs[j][i];
	
            	u[j][i] += jacel * res[j][i];
            	sum = sum + res[j][i] * res[j][i] ;

				}
			isw=1 - isw;
      	}
			jsw = 1 - jsw;
		}
      double sum2 = sum / nx / nx / ny / ny;
      double sum3 = Math.sqrt(sum2);

      return sum3;
   }


	public static void main(String[] args)throws java.io.IOException{
	mg relax = new mg();
	mg err   = new mg();
   double EPSILON = 0.00000001;
      if (args.length<4) {
         System.err.println(
            "Usage: java lev ncycles pre pst");
            return;
      }
		mg mm = new mg();
// now initialize the memory.....
		int levels,maxlev;
		levels = Integer.parseInt(args[0]);
      int ncycle = Integer.parseInt(args[1]);
      int pre = Integer.parseInt(args[2]);
      int pst = Integer.parseInt(args[3]);

		int[] nx = new int[levels];
		int[] ny = new int[levels];
		int nxf, nyf;
// use this in the c type loops, or should I say java loops
		maxlev = levels - 1;

// declare the 2d variables on all of the levels ....
		double [][][] u = new double[levels][][];
		double [][][] uxct = new double[levels][][];
		double [][][] rhs  = new double[levels][][];
		double [][][] tau  = new double[levels][][];
		double [][][] temp  = new double[levels][][];
//
		
		for (int i=0;i<levels;i++) {
			nx[i] = 1 + mm.power(2,i+1); 
			ny[i] = 1 + mm.power(2,i+1); 

			u[i]    = new double[ny[i]][nx[i]];
			uxct[i] = new double[ny[i]][nx[i]];
			rhs[i]  = new double[ny[i]][nx[i]];
			tau[i]  = new double[ny[i]][nx[i]];
			temp[i]  = new double[ny[i]][nx[i]];
		}

		nxf = nx[maxlev];
		nyf = ny[maxlev];
		System.out.println("nx,ny on finest grid= "+nxf+" "+nyf);
      double x[] = new double[nxf];
      double y[] = new double[nyf];
      double h;
      double l2norm,l2err;
      h = (2.0)/(nxf-1);

      for (int i=0;i<nxf;i++) {
         x[i] = -1.0 + (i)*h;
		}
      for (int i=0;i<nyf;i++) {
         y[i] = -1.0 + (i)*h;
      }


// put the data down on the finest level.....

		set_up_u(nxf,nxf,x,y,u[maxlev],uxct[maxlev],h);
      set_up_rhs(nxf,nxf,x,y,rhs[maxlev]); 

// first smooth on the finest grid
      for (int prec =0;prec<pre;prec++) {
         l2norm = relax.relaxc(nx[maxlev],ny[maxlev],u[maxlev],
                               rhs[maxlev],temp[maxlev],h);
         l2err = err.erroru(nx[maxlev],ny[maxlev],u[maxlev],uxct[maxlev]);
         System.out.println(+l2norm+"   " +l2err);
      }



// loop over a v cycle
		
      for (int cycle=0;cycle<ncycle;cycle++) {

// cycle from the finest to the coarsest
			for (int lev=maxlev;lev>=1;lev--) {
				lu(nx[lev],ny[lev],u[lev],h,temp[lev]);
				restrict(nx[lev],ny[lev],temp[lev],temp[lev-1]);
				restrict(nx[lev],ny[lev],u[lev],u[lev-1]);
				h = h * 2.0;
				lu(nx[lev-1],ny[lev-1],u[lev-1],h,tau[lev-1]);
				suba(nx[lev-1],ny[lev-1],tau[lev-1],temp[lev-1],tau[lev-1]);
				restrict(nx[lev],ny[lev],rhs[lev],rhs[lev-1]);
				adda(nx[lev-1],ny[lev-1],rhs[lev-1],tau[lev-1],rhs[lev-1]);
// at this point the truncation error has been added to the rhs 
// now we need to smooth on this grid (or solve.....)
				if ( (lev-1) == 0) {
// solve on the grid.....
         		do{
            		l2norm = relax.relaxc(nx[lev-1],ny[lev-1],u[lev-1],
                                  		rhs[lev-1],tau[lev-1],h);
         l2err = err.erroru(nx[lev-1],ny[lev-1],u[lev-1],uxct[lev-1]);
         		} while (l2norm > EPSILON);

				}
				else {
      		   for (int prec =0;prec<pre;prec++) {
         		   l2norm = relax.relaxc(nx[lev-1],ny[lev-1],u[lev-1],
                               		   rhs[lev-1],temp[lev-1],h);
      		   }
				}

			}

// now cycle back up to the finest grid (but not including the finest level
			for (int lev=0;lev<maxlev;lev++) {
				restrict(nx[lev+1],ny[lev+1],u[lev+1],temp[lev]);
				suba(nx[lev],ny[lev],u[lev],temp[lev],u[lev]);
				prolong(nx[lev+1],ny[lev+1],u[lev],temp[lev+1]);
				adda(nx[lev+1],ny[lev+1],u[lev+1],temp[lev+1],u[lev+1]);
				h = h * 0.5;
// now we apply some more smoothing sweeps
         	for (int prec =0;prec<pre;prec++) {
            	l2norm = relax.relaxc(nx[lev+1],ny[lev+1],u[lev+1],
                                  	 rhs[lev+1],temp[lev+1],h);
            	if (lev+1 == maxlev) {
						l2err = err.erroru(nx[lev+1],ny[lev+1],
                                     u[lev+1],uxct[lev+1]);
            		System.out.println(+l2norm+"   " +l2err);
         		}
				}
			}

		}  // the end of a vcycle
// now we just have swept on the finest grid!!!


// now print out the data.....

		print_uij(nx[maxlev],ny[maxlev],x,y,u[maxlev],"u.dat");
		print_uij(nx[maxlev],ny[maxlev],x,y,uxct[maxlev],"ux.dat");
		suba(nx[maxlev],ny[maxlev],u[maxlev],uxct[maxlev],temp[maxlev]);
		print_uij(nx[maxlev],ny[maxlev],x,y,temp[maxlev],"err.dat");

	}
}
